use std::fmt::{Display, Formatter};

#[derive(Debug)]
pub enum GitRef{
    Commit(String),
    Branch(String),
    Head,
}

impl GitRef {
    pub fn new_commit(s : String) -> GitRef {
        GitRef::Commit(s)
    }

    pub fn new_branch(s : String) -> GitRef {
        GitRef::Branch(s)
    }
}

impl Display for GitRef {
    fn fmt(&self, f: &mut Formatter<'_>) -> std::fmt::Result {
        write!(f, "{}", match &self {
            GitRef::Commit(s) => {s.as_str()}
            GitRef::Branch(s) => {s.as_str()}
            GitRef::Head => {"HEAD"}
        })
    }
}
