use actix_web::web::{Bytes, Buf};
use tokio::io::AsyncWriteExt;
use actix_web::error::PayloadError;

pub struct Writer<T>(pub T);

impl <T : tokio::io::AsyncWrite + Unpin> Writer<T> {
    pub async fn write(&mut self, bytes : Bytes) -> Result<(), PayloadError> {
        let write_all = self.0.write_all(bytes.bytes()).await;
        let res = write_all.map_err(|e| actix_web::client::PayloadError::Io(e));
        return res;
    }
}